'use strict'

exports.launch = launch

const util = require('../util')
const Logger = util.getLogger(__filename)
const httpServer = require('../http-server')

function launch (Context) {
  return new Promise((resolve, reject) => {
    httpServer.launch(Context, (err, server) => {
      if (err) return reject(err)

      Logger.info(`launched http server on ${server.url}`)
      Context.httpServer = server
      resolve()
    })
  })
}
