'use strict'

function createErrorObjects (names = []) {
  const types = {}

  for (let name of names) {
    // Use a destructuring trick to give the error class a variable name
    types[name] = ({[name]: class extends Error {
      constructor (m, extra = {}) {
        super(m)
        this.name = name
        for (let key of Object.keys(extra)) {
          this[key] = extra[key]
        }
      }
    }})[name]
  }

  return types
}

exports.errors = createErrorObjects([
  'InvalidSession',
  'NoLicense',
  'NoSession',
  'PermissionDenied',
  'SessionExpired',
  'TermsNotAccepted'
])
