'use strict'

exports.handleRequest = handleRequest

// Handle the HTTP request
function handleRequest (req, res) {
  const {
    commandBindAddr,
    dataBindAddr,
    bulkBindAddr
  } = req.nsConsole.context.config.sockets
  const { consoleURL } = req.nsConsole.context.config.notification

  // Compose hostname:port from the configured hostname and ports
  let hostname = 'localhost'
  let match = consoleURL.match(/:\/\/([^:/]*)/)
  if (match) {
    hostname = match[1]
  }
  let commandPort = `${hostname}:${portFromBindAddr(commandBindAddr) || 9001}`
  let dataPort = `${hostname}:${portFromBindAddr(dataBindAddr) || 9002}`
  let bulkPort = `${hostname}:${portFromBindAddr(bulkBindAddr) || 9003}`
  res.status(200)
  res.send({ commandPort, dataPort, bulkPort })
}

function portFromBindAddr (addrString) {
  if (!addrString) return
  const match = addrString.match(/:(\d+)/)
  if (match) return match[1]
}
