'use strict'

exports.handleRequest = handleRequest

const url = require('url')

const util = require('../../util')
const Logger = util.getLogger(__dirname, __filename)

// Handle the HTTP request
function handleRequest (req, res) {
  const context = req.nsConsole.context
  const config = context.config

  Logger.debug('handling request')

  const parsedUrl = url.parse((config && config.influxdb && config.influxdb.url) || '')
  const result = {
    host: parsedUrl.host,
    port: parsedUrl.port,
    version: config && config.influxdb && config.influxdb.version
  }

  res.status(200)
  res.send(result)
}
