'use strict'

const util = require('../../util')
const Logger = util.getLogger(__dirname, __filename)

exports.handleRequest = handleRequest

// Handle the HTTP request
function handleRequest (req, res) {
  const settingsManager = req.nsConsole.context.settingsManager
  settingsManager.getSettings('integrations', (err, settings) => {
    if (err) {
      Logger.error('Error listing integrations.', err)
      return res.status(500).send('Internal Server Error.')
    }

    res.status(200)
    res.send(settings || {})
  })
}
