'use strict'

exports.handleRequest = handleRequest

const nsolid = require('nsolid')
const util = require('../../util')
const Logger = util.getLogger(__dirname, __filename)

// Handle the HTTP request
function handleRequest (req, res) {
  const qData = req.nsConsole.qData
  const token = qData.token

  let valid
  try {
    valid = nsolid.validateToken(token).licensed
  } catch (err) {
    res.status(503)
    res.send({
      time: new Date().toISOString(),
      valid: false,
      error: { message: err.message }
    })
    Logger.error(err, 'Error checking token')
    return
  }

  const status = valid ? 200 : 404
  res.status(status)
  res.send({
    time: new Date().toISOString(),
    valid
  })
}
