#!/usr/bin/env node

'use strict'

const pj = require('./package.json')
const version = pj.version
const platform = require('./platform')()
const fs = require('fs')
const path = require('path')
const rimraf = require('rimraf')
const npm = require(path.dirname(process.argv[0]) + '/../lib/node_modules/npm/lib/npm.js')

console.log(`Checking for LevelDOWN ${version} for ${platform}`)

const platDir = `./lib/${platform}`

fs.stat(`${platDir}/leveldown`, err => {
  if (!err) {
    console.log(`Already installed.  Remove ${platDir}/leveldown if you want to reinstall it.`)
    return
  }

  npm.load({ save: false, prefix: './lib' }, err => {
    if (err) throw err
    npm.install('leveldown@^4.0.1', err => {
      if (err) throw err
      try {
        fs.statSync(platDir)
      } catch (err) {
        fs.mkdirSync(platDir)
      }
      const deps = require('./lib/node_modules/leveldown/package.json').dependencies
      pj.dependencies = deps
      fs.writeFileSync('package.json', JSON.stringify(pj, null, '  ') + '\n')
      fs.rename('./lib/node_modules/leveldown', `${platDir}/leveldown`, err => {
        if (err) throw err
        rimraf(`${platDir}/leveldown/src`, err => {
          if (err) throw err
        })
        rimraf(`${platDir}/leveldown/deps`, err => {
          if (err) throw err
        })
        rimraf(`${platDir}/leveldown/build/Release/deps`, err => {
          if (err) throw err
        })
        rimraf(`${platDir}/leveldown/build/Release/.deps`, err => {
          if (err) throw err
        })
        rimraf(`${platDir}/leveldown/build/Release/obj.target`, err => {
          if (err) throw err
        })
      })
    })
  })
})
