{
  'targets': [
    {
      'target_name': 'snapdiff',
      'include_dirs': [
        "<!(node -e \"require('nan')\")",
        'src',
        'src/api',
        'src/model',
        'src/parser',
        'src/worker',
        'deps/rapidjson/include',
        'deps/zstream'
      ],
      'sources': [
        'src/binding.cc',
        'src/util.cc',
        'src/api/aggregate.cc',
        'src/api/api.cc',
        'src/api/diff.cc',
        'src/model/common.cc',
        'src/parser/rapidjson_parser.cc',
        'src/parser/rapidjson_saxparser.cc',
        'src/parser/rapidjson_saxparser_zlib.cc',
        'src/worker/heap_snapshot.cc',
        'src/worker/heap_snapshot_edge.cc',
        'src/worker/heap_snapshot_edge_index_provider.cc',
        'src/worker/heap_snapshot_edge_iterator.cc',
        'src/worker/heap_snapshot_filered_iterator.cc',
        'src/worker/heap_snapshot_index_range_iterator.cc',
        'src/worker/heap_snapshot_item_provider.cc',
        'src/worker/heap_snapshot_node.cc',
        'src/worker/heap_snapshot_node_index_provider.cc',
        'src/worker/heap_snapshot_node_iterator.cc',
        'src/worker/heap_snapshot_nodes_provider.cc',
        'src/worker/heap_snapshot_retainer_edge.cc',
        'src/worker/heap_snapshot_retainer_edge_iterator.cc',
        'src/worker/js_heap_snapshot.cc',
        'src/worker/js_heap_snapshot_edge.cc',
        'src/worker/js_heap_snapshot_node.cc',
        'src/worker/js_heap_snapshot_retainer_edge.cc',

        # headers in case this is used to generate IDE projects
        'src/util.h',
        'src/api/aggregate.h',
        'src/api/api.h',
        'src/api/diff.h',
        'src/model/aggregate.h',
        'src/model/aggregate_for_diff.h',
        'src/model/aggregates.h',
        'src/model/allocation_node_callers.h',
        'src/model/allocation_stack_frame.h',
        'src/model/common.h',
        'src/model/comparator_config.h',
        'src/model/diff.h',
        'src/model/edge.h',
        'src/model/items_range.h',
        'src/model/node.h',
        'src/model/node_filter.h',
        'src/model/samples.h',
        'src/model/serialized_allocation_node.h',
        'src/model/serialized_item.h',
        'src/model/static_data.h',
        'src/model/statistics.h',
        'src/parser/parser.h',
        'src/parser/rapidjson_parser.h',
        'src/parser/rapidjson_saxhandler.h',
        'src/parser/rapidjson_saxparser.h',
        'src/parser/rapidjson_saxparser_zlib.h',
        'src/worker/allocation_profile.h',
        'src/worker/bottom_up_allocation_node.h',
        'src/worker/function_allocation_info.h',
        'src/worker/heap_snapshot.h',
        'src/worker/heap_snapshot_edge.h',
        'src/worker/heap_snapshot_edge_index_provider.h',
        'src/worker/heap_snapshot_edge_iterator.h',
        'src/worker/heap_snapshot_filered_iterator.h',
        'src/worker/heap_snapshot_filters.h',
        'src/worker/heap_snapshot_index_range_iterator.h',
        'src/worker/heap_snapshot_item.h',
        'src/worker/heap_snapshot_item_index_provider.h',
        'src/worker/heap_snapshot_item_iterator.h',
        'src/worker/heap_snapshot_item_provider.h',
        'src/worker/heap_snapshot_node.h',
        'src/worker/heap_snapshot_node_index_provider.h',
        'src/worker/heap_snapshot_node_iterator.h',
        'src/worker/heap_snapshot_nodes_provider.h',
        'src/worker/heap_snapshot_problem_report.h',
        'src/worker/heap_snapshot_progress.h',
        'src/worker/heap_snapshot_retainer_edge.h',
        'src/worker/heap_snapshot_retainer_edge_iterator.h',
        'src/worker/js_heap_snapshot.h',
        'src/worker/js_heap_snapshot_edge.h',
        'src/worker/js_heap_snapshot_node.h',
        'src/worker/js_heap_snapshot_retainer_edge.h',
        'src/worker/top_down_allocation_node.h'

        # rapidjson dep headers
        'deps/rapidjson/include/rapidjson/allocators.h',
        'deps/rapidjson/include/rapidjson/document.h',
        'deps/rapidjson/include/rapidjson/encodedstream.h',
        'deps/rapidjson/include/rapidjson/encodings.h',
        'deps/rapidjson/include/rapidjson/filereadstream.h',
        'deps/rapidjson/include/rapidjson/filewritestream.h',
        'deps/rapidjson/include/rapidjson/fwd.h',
        'deps/rapidjson/include/rapidjson/istreamwrapper.h',
        'deps/rapidjson/include/rapidjson/memorybuffer.h',
        'deps/rapidjson/include/rapidjson/memorystream.h',
        'deps/rapidjson/include/rapidjson/ostreamwrapper.h',
        'deps/rapidjson/include/rapidjson/pointer.h',
        'deps/rapidjson/include/rapidjson/prettywriter.h',
        'deps/rapidjson/include/rapidjson/rapidjson.h',
        'deps/rapidjson/include/rapidjson/reader.h',
        'deps/rapidjson/include/rapidjson/schema.h',
        'deps/rapidjson/include/rapidjson/stream.h',
        'deps/rapidjson/include/rapidjson/stringbuffer.h',
        'deps/rapidjson/include/rapidjson/writer.h',
        'deps/rapidjson/include/rapidjson/error/en.h',
        'deps/rapidjson/include/rapidjson/error/error.h',
        'deps/rapidjson/include/rapidjson/internal/biginteger.h',
        'deps/rapidjson/include/rapidjson/internal/diyfp.h',
        'deps/rapidjson/include/rapidjson/internal/dtoa.h',
        'deps/rapidjson/include/rapidjson/internal/ieee754.h',
        'deps/rapidjson/include/rapidjson/internal/itoa.h',
        'deps/rapidjson/include/rapidjson/internal/meta.h',
        'deps/rapidjson/include/rapidjson/internal/pow10.h',
        'deps/rapidjson/include/rapidjson/internal/regex.h',
        'deps/rapidjson/include/rapidjson/internal/stack.h',
        'deps/rapidjson/include/rapidjson/internal/strfunc.h',
        'deps/rapidjson/include/rapidjson/internal/strtod.h.',
        'deps/rapidjson/include/rapidjson/internal/swap.h',
        'deps/rapidjson/include/rapidjson/msinttypes/inttypes.h',
        'deps/rapidjson/include/rapidjson/msinttypes/stdint.h',

        # zstream headers (currently in use)
        'deps/zstream/izstream.hpp',
        'deps/zstream/izstream_impl.hpp'
      ],
      'xcode_settings': {
        'MACOSX_DEPLOYMENT_TARGET': '10.12',
        'OTHER_CFLAGS': [
            '-std=c++11',
            '-stdlib=libc++',
            '-fPIC',
            '-fwrapv',
            '-fno-strict-aliasing',
            '-fstack-protector-all',
            '-Winit-self',
            '-Wwrite-strings',
            '-Wdiv-by-zero',
            '-Wmissing-braces',
            '-Wmissing-field-initializers',
            '-Wno-sign-compare',
            '-Wno-unused-const-variable',
            '-g',
            '-O2',
            '-fvisibility=hidden',
            '-Wno-missing-field-initializers',
            '-Wno-missing-braces',
            '-Wno-unused-function',
            '-Wno-strict-overflow',
            '-Wno-unknown-pragmas'
        ],
        'GCC_ENABLE_CPP_EXCEPTIONS': 'YES'
      },
      'cflags_cc!': ['-fno-exceptions'],
      'cflags_cc': [
        '-fexceptions',
        '-Winit-self',
        '-Wwrite-strings',
        '-Wdiv-by-zero',
        '-Wmissing-braces',
        '-Wmissing-field-initializers',
        '-Wno-sign-compare',
        '-Wno-unknown-pragmas',
        '-Wno-missing-field-initializers',
        '-Wno-missing-braces',
        '-Wno-unused-parameter'
      ],
      'default_configuration': 'Debug',
      'configurations': {
        'Debug': {
          'defines': [ 'DEBUG', '_DEBUG' ],
          'cflags': [ '-Wall', '-Wextra', '-O0', '-g', '-ftrapv' ],
          'msvs_settings': {
            'VCCLCompilerTool': {
              'RuntimeLibrary': 1, # static debug
            },
          },
        },
        'Release': {
          'defines': [ 'NDEBUG' ],
          'cflags': [ '-Wall', '-Wextra', '-O3' ],
          'msvs_settings': {
            'VCCLCompilerTool': {
              'RuntimeLibrary': 0, # static release
            },
          },
        }
      }
    }
  ]
}
